package alfred.http

import alfred.BuildConfig
import alfred.BuildId
import alfred.Builds
import javax.enterprise.context.ApplicationScoped
import javax.inject.Inject
import javax.ws.rs.core.Response

@ApplicationScoped
class Security {

    @field:Inject
    lateinit var builds: Builds

    fun requireKey(build: BuildId, apikey: String?, block: (BuildConfig) -> Any): Response {
        val buildConfig = builds.buildConfig(build)
        if (buildConfig.apikey != "" && buildConfig.apikey != apikey) {
            return Response.status(Response.Status.UNAUTHORIZED).build()
        }

        val entity = block(buildConfig)
        if (entity is Response) {
            return entity
        }

        return Response.ok(entity).build()
    }

}
